package com.tongran.system.controller;

import com.tongran.common.core.utils.poi.ExcelUtil;
import com.tongran.common.core.web.controller.BaseController;
import com.tongran.common.core.web.domain.AjaxResult;
import com.tongran.common.core.web.page.TableDataInfo;
import com.tongran.common.log.annotation.Log;
import com.tongran.common.log.enums.BusinessType;
import com.tongran.common.security.annotation.RequiresPermissions;
import com.tongran.system.domain.RmSwitchInterfaceInfo;
import com.tongran.system.service.IRmSwitchInterfaceInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 交换机接口信息Controller
 * 
 * @author tongran
 * @date 2025-10-10
 */
@RestController
@RequestMapping("/switchInterfaceInfo")
@RequiresPermissions("rocketmq:switchInfo")
public class RmSwitchInterfaceInfoController extends BaseController
{
    @Autowired
    private IRmSwitchInterfaceInfoService rmSwitchInterfaceInfoService;

    /**
     * 查询交换机接口信息列表
     */
    @GetMapping("/list")
    public TableDataInfo list(RmSwitchInterfaceInfo rmSwitchInterfaceInfo)
    {
        startPage();
        List<RmSwitchInterfaceInfo> list = rmSwitchInterfaceInfoService.selectRmSwitchInterfaceInfoList(rmSwitchInterfaceInfo);
        return getDataTable(list);
    }

    /**
     * 导出交换机接口信息列表
     */
    @Log(title = "交换机接口信息", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, RmSwitchInterfaceInfo rmSwitchInterfaceInfo)
    {
        List<RmSwitchInterfaceInfo> list = rmSwitchInterfaceInfoService.selectRmSwitchInterfaceInfoList(rmSwitchInterfaceInfo);
        ExcelUtil<RmSwitchInterfaceInfo> util = new ExcelUtil<RmSwitchInterfaceInfo>(RmSwitchInterfaceInfo.class);
        util.exportExcel(response, list, "交换机接口信息数据");
    }

    /**
     * 获取交换机接口信息详细信息
     */
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return success(rmSwitchInterfaceInfoService.selectRmSwitchInterfaceInfoById(id));
    }

    /**
     * 新增交换机接口信息
     */
    @Log(title = "交换机接口信息", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody RmSwitchInterfaceInfo rmSwitchInterfaceInfo)
    {
        return toAjax(rmSwitchInterfaceInfoService.insertRmSwitchInterfaceInfo(rmSwitchInterfaceInfo));
    }

    /**
     * 修改交换机接口信息
     */
    @Log(title = "交换机接口信息", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody RmSwitchInterfaceInfo rmSwitchInterfaceInfo)
    {
        return toAjax(rmSwitchInterfaceInfoService.updateRmSwitchInterfaceInfo(rmSwitchInterfaceInfo));
    }

    /**
     * 删除交换机接口信息
     */
    @Log(title = "交换机接口信息", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(rmSwitchInterfaceInfoService.deleteRmSwitchInterfaceInfoByIds(ids));
    }
}
